From 0dcdb035b24f6847cb41f74ae7f8a7926b99c759 Mon Sep 17 00:00:00 2001
From: Sanket Markan <sanketmarkan@gmail.com>
Date: Wed, 9 Mar 2016 22:09:07 +0530
Subject: [PATCH] backup when vlmc closes unexpectedly

---
 src/Gui/MainWindow.cpp  | 13 ++++++++++---
 src/Main/main.cpp       |  2 +-
 src/Project/Project.cpp | 30 +++++++++++++++++++++++++++++-
 src/Project/Project.h   |  2 ++
 4 files changed, 42 insertions(+), 5 deletions(-)

diff --git a/src/Gui/MainWindow.cpp b/src/Gui/MainWindow.cpp
index 7cd5259..c54c846 100644
--- a/src/Gui/MainWindow.cpp
+++ b/src/Gui/MainWindow.cpp
@@ -847,9 +847,16 @@ MainWindow::restoreSession()
                                QMessageBox::Yes | QMessageBox::No, QMessageBox::Yes );
         if ( res == QMessageBox::Yes )
         {
-            //FIXME: We need a setting with the latest project file & restore the project.
-            QMessageBox::warning( this, tr( "Can't restore project" ), tr( "VLMC didn't manage to restore your project. We apology for the inconvenience" ) );
-        }
+            Core::getInstance()->project()->BackupFile();
+            if (Core::getInstance()->project()->hasProjectFile()== false)
+            {
+              QMessageBox::warning( this, tr( "Can't restore project" ), tr( "VLMC didn't manage to restore your project. We apology for the inconvenience" ) );
+            }
+            else
+            {
+              ret = true;
+            }
+          }
     }
     Core::getInstance()->settings()->setValue( "private/CleanQuit", true );
     return ret;
diff --git a/src/Main/main.cpp b/src/Main/main.cpp
index e3e412c..24d1f2a 100644
--- a/src/Main/main.cpp
+++ b/src/Main/main.cpp
@@ -161,7 +161,7 @@ VLMCGuimain( int argc, char **argv )
     }
 
     //Don't show the wizard if a project has been passed through command line.
-    if ( project == false )
+    if ( Core::getInstance()->project()->hasProjectFile() == false  )
         w.showWizard();
 
     /* Main Window display */
diff --git a/src/Project/Project.cpp b/src/Project/Project.cpp
index 37252af..2930e79 100644
--- a/src/Project/Project.cpp
+++ b/src/Project/Project.cpp
@@ -326,9 +326,37 @@ Project::autoSaveRequired()
 {
     if ( m_projectFile == NULL )
         return ;
-    saveProject( m_projectFile->fileName() + Project::backupSuffix );
+    const QString name = m_projectFile->fileName() + Project::backupSuffix;
+    const QString fileName = m_settings->value("vlmc/ProjectName")->get().toString();
+    saveProject( name );
+    createBackup(name,fileName);
+}
+
+void
+Project::createBackup(const QString Backupname,const QString fileName)
+{
+    const QString workSpace = VLMC_GET_STRING( "vlmc/WorkspaceLocation" );
+    QFile Backup(workSpace + "/backup~");
+    Backup.open(QIODevice::WriteOnly | QIODevice::Text);
+    QTextStream out(&Backup);
+    out << Backupname << "\n" << fileName;
+    Backup.close();
 }
 
+void
+Project::BackupFile()
+{
+    const QString workSpace = VLMC_GET_STRING( "vlmc/WorkspaceLocation" );
+    QFile Backup(workSpace + "/backup~");
+    Backup.open(QIODevice::ReadOnly | QIODevice::Text);
+    QString path = Backup.readLine();
+    if (path.isEmpty())
+        return;
+    path.remove('~');
+    QString fileName = Backup.readLine();
+    this -> newProject ( fileName,path);
+    return;
+}
 
 void
 Project::autoSaveEnabledChanged(const QVariant &enabled)
diff --git a/src/Project/Project.h b/src/Project/Project.h
index 17062d3..a3e8114 100644
--- a/src/Project/Project.h
+++ b/src/Project/Project.h
@@ -65,6 +65,8 @@ class Project : public QObject
          */
         bool            load(const QString& path);
         void            emergencyBackup();
+        void            BackupFile();
+        void            createBackup(const QString Backupname,const QString fileName);
         bool            isClean() const;
         void            closeProject();
         bool            hasProjectFile() const;
-- 
1.9.1

